;(note that some of the things I say in this file may be true anymore because
; of changing variables the executable without updating this text)

;SPC2MIDI Settings
Game=Zelda: A Link To The Past

;- Name to describe the sample. By default, any new samples found in an SPC
;  savestate are numbered sequentially, from "samp0000" to "samp9999". Also,
;  whenever copying sounds, a number will be attached to the end of it.
;  Copying "flute" and "trumpet3" would create "flute2" and "trumpet4".
;  Since many instrument sounds in games sound similar but with subtle
;  differences, they can be numbered sequentially; but for recognizability,
;  try to name them by attributes. For example, rather than "flute" and
;  "flute2", try "Flute-Bright" and "Flute-Dull". Put the description after
;  the instrument name so that sorting and searching will list starting with
;  the type.
;- Length is the sample length of the sound.
;- LoopLen is the sample length of the loop portion.
;- CheckSum is the total of all the raw dwords in both the sample and
;  its loop portion. Odd bytes at the top of a dword are zeroed. The
;  checksum is used to automatically associate samples in the SPC or ZST
;  to their proper attributes.
;- Pitch is the perceived pitch when the sample is played at 32khz, with note
;  number 69 being 440hz (or A5 above middle C).
;- Volume is the equivalent MIDI volume level (1-127) when the sample is
;  played at full volume.
;- Instrument is either a general MIDI instrument or custom sound effect that
;  most closely matches the sample's sound. Usually general MIDI instruments
;  suffice, but for more similarity to the actual sound, custom FM sound
;  effects can be used instead of the default patches. It is also useful to
;  define extra instruments for synthesizers that use banks to provide more
;  than the 128 instrument standard.
;- Bank is optional for sequencers or synthesizers that support more than the
;  standard MIDI 128 instruments.
;- Flags are miscellaneous bits for determining sample attributes.
SampleSettings=Name,Length,LoopLen,CheckSum,Pitch,Volume,Instrument,Bank,Flags
Samples
{
  0="Flute",840,48,1747A638,69,127,64,30572,M
  1="Drum",2080,96,837BD092,77,64
  2="Ocarina",496,128,123EF8A9,98,127
  3="Piano",248,64,976F3CE1,73,127,1
  6="Trumpet-Royal",1020,64,8BE5A526,82,34
  7="Rain",132,132,3616BE0C,108,128
}
;- Patch is the instrument number (0-127) within the current bank.
;- Bank is a block of instruments. Banks can be used by synthesizers to
;  access more instruments than the standard 128.
;- GmPatch is closest general MIDI instrument to that of the synthesizer's
;  for devices that only support the standard 128. When exporting an MIDI for
;  use with a synthesizer, the extended bank/patch combination will be used.
;  When exporting for listening on a computer, the GmPatch is used.
;- Type describes how the sound is generated, whether by wind, reed, string,
;  percussion, and the like. It is simply used for grouping.
;- FmAtrs are the attributes to synthesize the sound through an OPL2 FM chip.
;  Every two hex characters is byte, for a total of 11 attributes for the
;  carrier and modulator wave, including:
;    Modulator multiple of the
;    Carrier multiple
;    Modulator volume
;    Carrier volume
;    Modulator attack rate/decay rate
;    Carrier AD
;    Modulator sustain level/release rate
;    Carrier SR
;    Modulator waveform
;    Carrier waveform
;    Modulator feedback strength
InstrumentSettings=Name,Patch,Bank,GmPatch,Type,FmAtrs
Instruments
{
  ;Note that numbering starts at 256 rather than 0 because 0-255 are already
  ;defined, 0-127 as general MIDI instruments as 128+ as percussion.
  256="Chime Harp",23,0,126,2023404360638083E0E3C0
  257="Chirp Whistle",24,0,87,01020010F499FF88
  258="Glass Blow",25,1,1,01020010F488FF88
  259="Glock Vibraphone",26,2,0,01040010F4AA8888  
  260="Sitar",27,3,5,01010010C4884433
  261="Carnival",28,0,28,01020010C4884433
  262="Wood Glock",29,7,2,01020010C4F84444
  263="Marimba",30,0,13,0103001075991688
}
FileDefaults
{
  zelda.zst
  {
    Name="Opening Tune"
    ;If a particular channel has samples which are undefined yet, the entire
    ;channel can simply be muted to rid the exported MIDI of the offending
    ;sounds.
    MutedChannels=8
    ;Muting an entire channel has the drawback that it mutes all instruments
    ;played on that channel, even if they do sound okay, So similarly, if there
    ;is a particular sample that does not sound good in the conversion, it
    ;alone can be muted.
    MutedSamples
    {
      23
    }
    ;The SPC700 has a 64khz timer for very precise timing, although usually
    ;the less accurate (but more than adequate) 8khz timers are used. Markers
    ;are simply stored as the number of 64khz timer increments at the desired
    ;point in the song.
    Markers
    {
      187892
      402938
      1047352
      6725321
      8927345
    }
  }
  zelda.sp3
  {
    ;Although SPC's may include names within them, savestates do not, so this
    ;field is available.
    Name="Boss Music"
    Markers
    {
      34729819
    }
  }
  ;There are no markers for this file, so none were saved.
  zelda.zs7
  {
    Name="Fairy Music"
  }
}
